package cn.efunbox.base;

import cn.efunbox.base.configuration.WebApiConfig;
import cn.efunbox.base.data.ProjectSimpleJpaRepository;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.context.annotation.Import;
import org.springframework.data.jpa.repository.config.EnableJpaRepositories;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RestController;

@SpringBootApplication
@RestController
@EnableScheduling
@Import(WebApiConfig.class)
@EnableJpaRepositories(repositoryBaseClass = ProjectSimpleJpaRepository.class)
public class BaseApplication {
	public static void main(String[] args) {
		SpringApplication.run(BaseApplication.class, args);
	}

    /**
     * 健康检查check
     * @return
     */
    @GetMapping(value="/check")
    public String check(){
        return  "ok";
    }
}
