package cn.efunbox.base.configuration;

import cn.efunbox.base.result.ApiCode;
import cn.efunbox.base.result.ApiResult;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.ControllerAdvice;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.ResponseBody;

@Slf4j
@ControllerAdvice
@ResponseBody
public class WebExceptionHandler {

    @ExceptionHandler
    public ApiResult unknownException(Exception e) {
      log.error("未知异常",e);
      return ApiResult.error(ApiCode.UNKNOWN_ERROR);
    }
}
