package cn.efunbox.base.controller;

import cn.efunbox.base.configuration.annotation.CommonApi;
import cn.efunbox.base.entity.User;
import cn.efunbox.base.result.ApiResult;
import cn.efunbox.base.service.UserService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@Slf4j
@CommonApi
@Api(tags = "用户相关接口")
@RestController
@RequestMapping(value = "/user")
public class UserController {

    @Autowired
    UserService userService;

    @ApiOperation(value = "获取用户信息", notes = "获取用户信息接口")
    @GetMapping
    public ApiResult<User> getMemberById(@RequestHeader(value = "uid") String uid) {
        return userService.getUserById(uid);
    }


}
