package cn.efunbox.base.entity;

import cn.efunbox.base.enums.BaseStatusEnum;
import lombok.Data;
import lombok.ToString;
import org.hibernate.annotations.DynamicInsert;
import org.hibernate.annotations.DynamicUpdate;

import javax.persistence.*;
import java.io.Serializable;
import java.util.Date;

/**
 * Member
 * Created by xusq on 2019/12/31.
 */
@Data
@ToString
@Entity
@DynamicInsert
@DynamicUpdate
@Table(name = "user")
public class User implements Serializable {

    @Id
    private String uid;

    private String eid;

    @Column(name = "mobile_no")
    private String mobileNo;

    @Column(name = "open_id")
    private String openId;

    @Column(name = "nick_name")
    private String nickName;

    private Integer gender;

    @Enumerated(EnumType.ORDINAL)
    private BaseStatusEnum status;

    private String avatar;

    @Column(name = "gmt_created")
    private Date gmtCreated;

    @Column(name = "gmt_modified")
    private Date gmtModified;

}
