package cn.efunbox.base.service.impl;

import cn.efunbox.base.entity.User;
import cn.efunbox.base.repository.UserRepository;
import cn.efunbox.base.result.ApiCode;
import cn.efunbox.base.result.ApiResult;
import cn.efunbox.base.service.UserService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Objects;

@Slf4j
@Service
public class UserServiceImpl implements UserService {


    @Autowired
    UserRepository userRepository;

    @Override
    public ApiResult getUserById(String id) {
        User user = userRepository.find(id);

        return ApiResult.ok(user);
    }

    @Override
    public ApiResult update(User member) {
        if (Objects.isNull(member)) {
            return ApiResult.error(ApiCode.PARAMETER_ERROR);
        }
        userRepository.update(member);
        return ApiResult.ok(member);
    }

}
